unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  cboxbmp, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    ScrollingTextBmp1: TScrollingTextBmp;
    Panel1: TPanel;
    Image1: TImage;
    ScrollingTextBmp2: TScrollingTextBmp;
    Panel2: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label8: TLabel;
    Timer1: TTimer;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure ScrollingTextBmp1Scroll(Sender: TObject; comp: TControl;
      screvent: TcbScrollEvent);
    procedure ScrollingTextBmp2Scroll(Sender: TObject; comp: TControl;
      screvent: TcbScrollEvent);
    procedure ScrollingTextBmp2Draw(Sender: TObject; bmp: TBitmap);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1  : TForm1;
  fpst   : string;
  fps    : integer;

implementation

{$R *.DFM}

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    ScrollingTextBMP1.HaltScroll;
    ScrollingTextBMP2.HaltScroll;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
    Randomize;
    case Random(2) of
         0 : ScrollingTextBmp1.ScrollType := stNormal;
         1 : ScrollingTextBmp1.ScrollType := stBounce;
     end;
     if ScrollingTextBmp1.ScrollType = stBounce then begin
        case Random(4) of
             0 : ScrollingTextBmp1.ScrollDirection := sdUp;
             1 : ScrollingTextBmp1.ScrollDirection := sdDown;
             2 : ScrollingTextBmp1.ScrollDirection := sdLeft;
             3 : ScrollingTextBmp1.ScrollDirection := sdRight;
        end;
     end else begin
         case Random(2) of
              0 : ScrollingTextBmp1.ScrollDirection := sdUp;
              1 : ScrollingTextBmp1.ScrollDirection := sdDown;
         end;
    end;
    ScrollingTextBMP1.StartScroll;
    ScrollingTextBMP2.StartScroll;
end;

procedure TForm1.ScrollingTextBmp1Scroll(Sender: TObject; comp: TControl;
  screvent: TcbScrollEvent);
begin
    if not (comp is TLabel) then Exit;
    case screvent of
         seUp, seLeft    : (comp as TLabel).Font.Color := clWhite;
         seDown, seRight : (comp as TLabel).Font.Color := clYellow;
    end;
end;

procedure TForm1.ScrollingTextBmp2Scroll(Sender: TObject; comp: TControl;
  screvent: TcbScrollEvent);
begin
     //
     if not (comp is TLabel) then Exit;
    case screvent of
         seUp, seLeft    : (comp as TLabel).Font.Style := [fsBold];
         seDown, seRight : (comp as TLabel).Font.Style := [fsBold, fsItalic];
    end;

end;

procedure TForm1.ScrollingTextBmp2Draw(Sender: TObject; bmp: TBitmap);
begin
    Inc(fps);
    bmp.Canvas.Font.Assign(Form1.Font);
    bmp.Canvas.TextOut(0, 0, fpst);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
   fpst := Format('fps %-2n', [fps / 2]); 
   fps := 0;
end;

end.
